//------------------------------------------------------------------
#property  copyright ""
#property  link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  Red

//
//
//
//
//

extern string TimeFrame = "";
extern int    Fast      = 5;
extern int    Slow      = 34;

double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double ExtBuffer4[];

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtBuffer1);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" AC+AO("+Fast+")("+Slow+")");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtBuffer1[0] = limit+1; return(0); }


   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)  ExtBuffer3[i]=iMA(NULL,0,Fast,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,Slow,0,MODE_SMA,PRICE_MEDIAN,i);
      for(i=limit; i>=0; i--)
      {
         ExtBuffer1[i] = EMPTY_VALUE;
         ExtBuffer2[i] = EMPTY_VALUE;
         ExtBuffer4[i] = iMAOnArray(ExtBuffer3,0,Fast,0,MODE_SMA,i);
            double current_AO = ExtBuffer3[i];
            double prev_AO    = ExtBuffer3[i+1];
            double current_AC = ExtBuffer3[i]-ExtBuffer4[i];
            double prev_AC    = ExtBuffer3[i+1]-ExtBuffer4[i+1];
      
         if(current_AC>prev_AC && current_AO>prev_AO && current_AO<0) ExtBuffer1[i]= 1;
         if(current_AC<prev_AC && current_AO<prev_AO && current_AO>0) ExtBuffer2[i]=-1;
         
      }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ExtBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast,Slow,0,y);
         ExtBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast,Slow,1,y);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
return(s);
}

